import shutil
import os

desktop_file_location = "/usr/share/applications/io.github.giantpinkrobots.varia.desktop"

def copy_autostart_file():
    if os.name == 'posix':
        shutil.copyfile(desktop_file_location, os.path.join(os.getenv('HOME'), '.config/autostart/io.github.giantpinkrobots.varia.desktop'))

        if 'SNAP' in os.environ or 'FLATPAK_ID' in os.environ:
            with open(os.path.join(os.getenv('HOME'), '.config/autostart/io.github.giantpinkrobots.varia.desktop'), "r") as f:
                lines = f.readlines()

            with open(os.path.join(os.getenv('HOME'), '.config/autostart/io.github.giantpinkrobots.varia.desktop'), "w") as f:
                for line in lines:
                    if line.startswith("Exec="):
                        if 'SNAP' in os.environ:
                            f.write(f"Exec=snap run varia\n")
                        elif 'FLATPAK_ID' in os.environ:
                            f.write(f"Exec=flatpak run io.github.giantpinkrobots.varia\n")

                    else:
                        f.write(line)

        print("Copied desktop file to .config/autostart")

def delete_autostart_file():
    if os.name == 'posix':
        os.remove(os.path.join(os.getenv('HOME'), '.config/autostart/io.github.giantpinkrobots.varia.desktop'))
        print("Removed desktop file from .config/autostart")
